//Proyecto de Iniciación a la programación paralela en los módulos de informática
//Universidad de Murcia - Instituto de Enseñanza Secundaria Ingeniero de la Cerva, Murcia
//2014

//Ejemplo básico de captura de flujo de entrada de un proceso esclavo, en Java
//este es el proceso esclavoo, que se pone en marcha desde el proceso maestro

//En linux, 
//compilar el maestro y el esclavo, con: 
//javac esclavo.java
//javac maestro.java
//ejecutar el maestro con: java maestro N
//con N un número que se pasa al esclavo al ponerlo en marcha,
//y este lo pasa al maestro a través del flujo de entrada

import java.io.*;
import java.util.Arrays;

public class esclavoOrdenar
{

    private static int n;
    private static int[]  datos;

    public static void generar(int x[],int t)
    //se generan t datos reales con valores entre -10 y 10
    {
         int i;

         for(i=0;i<t;i++)
        {  
            x[i] =-100 + (int) ((float) Math.random() * 200);
        }
    }

    public static void copiar(int x[],int y[],int ini,int fin)
    {
        int i,j;
        
        for(i=ini,j=0;i<fin;i++,j++)
        {
            y[j]=x[i];
        }
    }

   public static void ordenar(int x[],int izq,int der)
  {
      int i,j;
      int temp;

      for(i=izq;i<der;i++)
      {
          for(j=i+1;j<der;j++)
          {
               if(x[i]>x[j])
               {
                   temp=x[i];
                   x[i]=x[j];
                   x[j]=temp;
               }
           }
       }
    }

   public static void main(String args[])
   {
        n=Integer.parseInt(args[0]);
        datos=new int[n];
        int[] datos1=new int[n/2];
        int[] datos2=new int[n-n/2];
        int[] copiadatos=new int[n];
	long ti,tf;
	
	generar(datos,n);
        copiar(datos,copiadatos,0,n);
	copiar(datos,datos1,0,n/2);
        copiar(datos,datos2,n/2,n);
//Si se quiere escribir los datos hay que quitar los comentarios de las líneas correspondientes
//        escribir(datos,n);
//        escribir(copiadatos,n);

        ti = System.currentTimeMillis();
        ordenar(copiadatos,0,n);
        tf= System.currentTimeMillis()-ti;
    
        System.out.format("Tiempo secuencial: %d microsegundos\n",tf);
	System.out.format("%s\n",Arrays.toString(copiadatos));
	ti = System.currentTimeMillis();
	System.out.format("%s\n",String.valueOf(ti));
	System.out.format("%s\n",Arrays.toString(datos1));
	ordenar(datos2,0,n-n/2);
	System.out.format("%s\n",Arrays.toString(datos2));
//la salida la coge el maestro, que ha puesto en marcha al esclavo y a capturado su flujo de salida
//       System.out.println(s+" "+args[0]);
 
   } // Fin del método.
 
} // Fin de la clase.

